#!/usr/bin/env python
# -*- coding:utf-8 -*-

import unittest
import timing
import time
import threading


class TimingTest(unittest.TestCase):
    @staticmethod
    def print_1():
        print(1)

    def test_timing_run(self):
        print('test_timing_run start')
        time_start = time.time()
        p1 = self.print_1
        timing.add_task('task1', 3, p1, 3)
        t = threading.Thread(target=timing.run)
        t.setDaemon(True)
        t.start()
        t.join(10)

        time_end = time.time()
        # print('start')
        # time.sleep(10)
        # print('end')
        self.assertEqual(len(timing.defaultTiming.task), 0)
        self.assertEqual(int(time_end - time_start), 10)


if __name__ == '__main__':
    unittest.main()
